%global momorel 2

Summary: NFS utlilities and supporting daemons for the kernel NFS server.
Name: nfs-utils
Version: 1.0.8
Release: %{momorel}m

# group all 32bit related archs
%define all_32bit_archs %{ix86}

Source0: http://dl.sourceforge.net/sourceforge/nfs/nfs-utils-%{version}.tar.gz
NoSource: 0
Source1: http://dl.sourceforge.net/sourceforge/nfs/nfs.doc.tar.gz

Source10: nfs.init
Source11: nfslock.init
Source12: rpcidmapd.init
Source13: rpcgssd.init
Source14: rpcsvcgssd.init

Patch50: nfs-utils-1.0.5-statdpath.patch
Patch51: nfs-utils-1.0.6-mountd.patch
Patch52: nfs-utils-1.0.6-idmap.conf.patch
Patch54: nfs-utils-1.0.7-mountd-stat64.patch
Patch55: nfs-utils-1.0.7-nfsd-ctlbits.patch

Patch100: nfs-utils-1.0.8-compile.patch

Group: System Environment/Daemons
Obsoletes: nfs-server
Obsoletes: knfsd
Obsoletes: knfsd-clients
Obsoletes: nfs-server-clients 
Obsoletes: knfsd-lock
Provides: nfs-server 
Provides: nfs-server-clients 
Provides: knfsd-lock 
Provides: knfsd-clients 
Provides: knfsd
License: GPL
Buildroot: %{_tmppath}/%{name}-%{version}-root
Requires: portmap >= 4.0, sed, gawk, sh-utils, fileutils, textutils, grep
Requires: modutils >= 2.4.26-9
BuildPrereq: nfs-utils-lib-devel libevent-devel libgssapi-devel
BuildRequires: krb5-libs >= 1.4 autoconf >= 2.57 openldap-devel >= 2.2
BuildRequires: nfs-utils-lib-devel >= 1.0.8
BuildRequires: libevent-devel libgssapi-devel
PreReq: shadow-utils >= 4.0.3-25
PreReq: chkconfig util-linux
PreReq: nfs-utils-lib >= 1.0.8 libevent libgssapi

%description
The nfs-utils package provides a daemon for the kernel NFS server and
related tools, which provides a much higher level of performance than the
traditional Linux NFS server used by most users.

This package also contains the showmount program.  Showmount queries the
mount daemon on a remote host for information about the NFS (Network File
System) server on the remote host.  For example, showmount can display the
clients which are mounted on that host.

%prep
%setup -q -a1
%patch50 -p1 -b .statdpath
%patch51 -p1 -b .mountd
%patch52 -p1 -b .conf
%patch54 -p1 -b .stat64
%patch55 -p1 -b .ctlbits

# Do the magic to get things to compile
%patch100 -p1 -b .compile

# Remove .orig files
find . -name "*.orig" | xargs rm -f

%build

%ifarch s390 s390x
PIE="-fPIE"
%else
PIE="-fpie"
%endif
export PIE

sh -x autogen.sh

CFLAGS="`echo $RPM_OPT_FLAGS $ARCH_OPT_FLAGS $PIE`"
%configure \
	CFLAGS="$CFLAGS" \
	CPPFLAGS="$DEFINES" \
	LDFLAGS="-pie" \
	--prefix=$RPM_BUILD_ROOT

make all

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}{/sbin,/usr/sbin}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/{man5,man8}
mkdir -p %{buildroot}%{_initscriptdir}
make DESTDIR=%{buildroot} install
install -s -m 755 tools/rpcdebug/rpcdebug %{buildroot}/sbin
install -m 755 %{SOURCE10} %{buildroot}%{_initscriptdir}/nfs
install -m 755 %{SOURCE11} %{buildroot}%{_initscriptdir}/nfslock
install -m 755 %{SOURCE12} %{buildroot}%{_initscriptdir}/rpcidmapd
install -m 755 %{SOURCE13} %{buildroot}%{_initscriptdir}/rpcgssd
install -m 755 %{SOURCE14} %{buildroot}%{_initscriptdir}/rpcsvcgssd

install -m 644 utils/idmapd/idmapd.conf \
	%{buildroot}/etc/idmapd.conf

mkdir -p %{buildroot}/var/lib/nfs/rpc_pipefs

touch %{buildroot}/var/lib/nfs/rmtab
mv %{buildroot}/usr/sbin/{rpc.lockd,rpc.statd} %{buildroot}/sbin

mkdir -p %{buildroot}/var/lib/nfs/statd

# we are using quotad from quota utils
rm %{buildroot}/%{_mandir}/man8/rquotad*
rm %{buildroot}/%{_mandir}/man8/rpc.rquotad*
rm %{buildroot}/%{_sbindir}/rpc.rquotad

%clean
rm -rf %{buildroot}

%pre
# move files so the running service will have this applied as well
for x in gssd svcgssd idmapd ; do
	if [ -f /var/lock/subsys/rpc.$x ]; then
		mv /var/lock/subsys/rpc.$x /var/lock/subsys/rpc$x
	fi
done

/usr/sbin/useradd -l -c "RPC Service User" -r \
        -s /sbin/nologin -u 29 -d /var/lib/nfs rpcuser 2>/dev/null || :
# Define the correct unsigned uid value for 32 or 64 bit archs
%ifarch %{all_32bit_archs}
%define nfsnobody_uid   65534
%else
%define nfsnobody_uid   4294967294
%endif

# If UID 65534 (or 4294967294 64bit archs) is unassigned, create user "nfsnobody"
cat /etc/passwd | cut -d':' -f 3 | grep --quiet %{nfsnobody_uid} 2>/dev/null
if [ "$?" -eq 1 ]; then
	/usr/sbin/useradd -l -c "Anonymous NFS User" -r \
		-s /sbin/nologin -u %{nfsnobody_uid} -d /var/lib/nfs nfsnobody 2>/dev/null || :
fi

%post
/sbin/chkconfig --add nfs
/sbin/chkconfig --add nfslock
/sbin/chkconfig --add rpcidmapd
/sbin/chkconfig --add rpcgssd
/sbin/chkconfig --add rpcsvcgssd

%preun
if [ "$1" = "0" ]; then
    /etc/init.d/nfs stop
    /etc/init.d/rpcgssd stop
    /etc/init.d/rpcidmapd stop
    /etc/init.d/nfslock stop
    /sbin/chkconfig --del rpcidmapd
    /sbin/chkconfig --del rpcgssd
    /sbin/chkconfig --del rpcsvcgssd
    /sbin/chkconfig --del nfs
    /sbin/chkconfig --del nfslock
    /usr/sbin/userdel rpcuser 2>/dev/null || :
    /usr/sbin/groupdel rpcuser 2>/dev/null || :
    /usr/sbin/userdel nfsnobody 2>/dev/null || :
fi

%postun
if [ "$1" -ge 1 ]; then
	/etc/init.d/rpcidmapd condrestart > /dev/null
	/etc/init.d/rpcgssd condrestart > /dev/null
	/etc/init.d/nfs condrestart > /dev/null
fi

%triggerpostun -- nfs-server
/sbin/chkconfig --add nfs

%triggerpostun -- knfsd
/sbin/chkconfig --add nfs

%triggerpostun -- knfsd-clients
/sbin/chkconfig --add nfslock

%files
%defattr(-,root,root)
%config /etc/init.d/nfs
%config /etc/init.d/nfslock
%config /etc/init.d/rpcidmapd
%config /etc/init.d/rpcgssd
%config /etc/init.d/rpcsvcgssd
%config(noreplace) /etc/idmapd.conf
%dir /var/lib/nfs/rpc_pipefs
%dir /var/lib/nfs
%dir %attr(700,rpcuser,rpcuser) /var/lib/nfs/statd
%config(noreplace) /var/lib/nfs/xtab
%config(noreplace) /var/lib/nfs/etab
%config(noreplace) /var/lib/nfs/rmtab
%config(noreplace) /var/lib/nfs/state
%doc nfs/*.html nfs/*.ps linux-nfs/*
/sbin/rpcdebug
/sbin/rpc.lockd
/sbin/rpc.statd
/usr/sbin/exportfs
/usr/sbin/nfsstat
/usr/sbin/nhfs*
/usr/sbin/rpc.mountd
/usr/sbin/rpc.nfsd
/usr/sbin/showmount
/usr/sbin/rpc.idmapd
/usr/sbin/rpc.gssd
/usr/sbin/rpc.svcgssd
/usr/sbin/gss_clnt_send_err
/usr/sbin/gss_destroy_creds
%{_mandir}/*/*

%changelog
* Fri Jul 28 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.8-2m)
- stop all daemon for stable release

* Fri Jun  9 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.8-1m)
- sync with fc

* Sat Jan 14 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.7-1m)
- sync with fc-devel
- enable nfs v4

* Thu Jan 12 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (1.0.6-8m)
- build fix for rquotad

* Mon Jul 25 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.6-7m)
- modify nfs.init

* Wed Jul 20 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.6-6m)
- revert 1.0.6-2m

* Sun Apr 17 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.6-5m)
- stop rpcidmapd rpcgssd nfslock

* Sat Apr  9 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.6-4m)
- ummm, who's gonna mount /var/lib/nfs/rpc_pipefs?

* Wed Mar  9 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.6-3m)
- sync with FC3(1.0.6-52).
- nfs-utils-1.0.6-statddos_quotabuf.patch and
  nfs-utils-1.0.6-auth_reload.patch is applied as another name.

* Wed Dec  8 2004 TAKAHASHI Tamotsu <tamo>
- (1.0.6-2m)
- apply some of UBUNTU patches
 - Patch0: nfs-utils-1.0.6-statddos_quotabuf.patch
  (CAN-2004-1014: ignore SIGPIPE to fix a DoS vulnerability)
  (CAN-2004-0946: do not use memcpy to fix a buffer overflow on 64 bit platforms)
 - Patch1: nfs-utils-1.0.6-auth_reload.patch
  (call auth_reload more often)

* Sun Aug 29 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (1.0.6-1m)
- updated to 1.0.6

* Wed Jul 21 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.3-5m)
- add uid/gid

* Wed Mar 31 2004 Toru Hoshina <t@momonga-linux.org>
- (1.0.3-4m)
- revised spec. rpc.rquotad belongs quota package.

* Thu Mar 25 2004 Toru Hoshina <t@momonga-linux.org>
- (1.0.3-3m)
- revised spec for rpm 4.2.

* Wed Jul 16 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (1.0.3-2m)
- add nfsstat-overflow.patch

* Tue Jun  3 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.0.3-1m)
  update to 1.0.3

* Wed Oct 24 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.3.3-8k)
- modify rpc.statd location to /sbin on init script

* Fri Oct 19 2001 Toru Hoshina <t@kondara.org>
- (0.3.3-6k)
- require quota 3.0.1
- move rpc.statd to /sbin.

* Fri Oct 12 2001 Toru Hoshina <t@kondara.org>
- (0.3.3-4k)
- revised nfslock.init to use /usr/sbin/rpc.statd instead of /sbin...

* Sat Sep 29 2001 Toru Hoshina <t@kondara.org>
- (0.3.3-2k)
- nfs.statd...

* Fri Apr 13 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.3.1-2k)
- backport from Jirai

* Fri Apr 13 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (0.3.1-3k)
- upgrade to 0.3.1
- change source URL and URL: tag.
- remove rpc.statd, rpc.lockd (kernels >= 2.2.18+ have automatic NFS lock)
- enable NFSv3

* Thu Mar 15 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.2.1-9k)
- rebuild against glibc-2.2.2 and add nfs-utils.glibc222.time.patch

* Sat Feb  3 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.2.1-7k)
- rebuild againt rpm-3.0.5-39k

* Tue Nov 28 2000 Toru Hoshina <toru@df-usa.com>
- use _initscriptdir macro to keep backword compatibility.

* Sun Nov 19 2000 AYUHANA Tomonori <l@kondara.org>
- (0.2.1-1k)
- upgrade 0.1.9.1-3k to 0.2.1-1k
- remove Distribution
- obey FHS

* Wed Jul 19 2000 AYUHANA Tomonori <l@kondara.org>
- (0.1.9.1-1k)
- ported from RedHat-6.2 Updates
- Be a NoSrc :-P
- rebuild against glibc-2.1.91, X-4.0, rpm-3.0.5
- SPEC fixed ( Distribution, BuildRoot, URL, Source )
- use %configure
- add SBINDIR and MAN*DIR at make install

* Mon Jul 17 2000 Matt Wilson <msw@redhat.com>
- 0.1.9.1
- remove patch0, has been integrated upstream

* Wed Feb  9 2000 Bill Nottingham <notting@redhat.com>
- the wonderful thing about triggers, is triggers are wonderful things...

* Thu Feb 03 2000 Cristian Gafton <gafton@redhat.com>
- switch to nfs-utils as the base tree
- fix the statfs patch for the new code base
- single package that obsoletes everything we had before (if I am to keep
  some traces of my sanity with me...)

* Mon Jan 17 2000 Preston Brown <pbrown@redhat.com>
- use statfs syscall instead of stat to determinal optimal blksize
